/*****************************************************************************
**
** program_ugnx3_create_fpdf.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.

  FPDF()

//1.     RIVET
//2.    


C   FPDF 

rivet			  (   )

	Work		
	Metal		
	Techno	


path			 : 
				a)       
				  ,   **.XXXX.***.***.**
				b)      5 
				(      )

pr_code			 
				 
				(    5 )

ad_code			 
				 
				(    5 )

fast_code		    rivet_spectrum ( . 7-11),
				  
				(     
				    fast_code,  12 )

grip_lng		 ,    fast_code  
				  
				(     
				    grip_lng,  3 )


point_id		 
				     
				     _XX
				    1-99
				


**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif



#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>




FILE*		prterr;
int			errorCode;
tag_t		rivet_bag[30000];
int			rivet_count;


#define	PRTERR(line)if(errorCode)\
	{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}




static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s		line=%d	\n",
			errorCode,message,line);
	}
}


static void cycle_components(tag_t	object)
{
	int	
		title_type,
		type=UF_ATTR_string,
		flag,
		component_count,
		i,j;

	char*
		title="RIVET";

	tag_t*
		child_components;

	//   <object>
	//   <child_components>
	
	component_count=UF_ASSEM_ask_part_occ_children(object,&child_components);

	//  ,    

	if(component_count==0)
	{
		//   
		flag=1;
		for(j=0;j<rivet_count;j++)
			if(object==rivet_bag[j])
			{
				flag=0;
				break;
			}
		if(flag)
			{//-----------------------------------------
				errorCode=UF_ATTR_find_attribute
					(object,type,title,&title_type);
				PRTERR(__LINE__);
				if(title_type==UF_ATTR_string)
					{//---------------------
						rivet_bag[rivet_count]=object;
						rivet_count++;
					}//---------------------
			}//-----------------------------------------
	}


	//    
	//       
	else
	{
		for(i=0;i<component_count;i++)
			cycle_components(child_components[i]);
		UF_free(child_components);

	}

term:
	return;
}



void do_it(void)
{

	//1.     RIVET
	{
		tag_t	disp_part;

		//   
		disp_part=UF_PART_ask_display_part();
		if(disp_part==NULL_TAG)
		{
			uc1601(", _, !   (:-) ",1);
			fprintf(prterr,"    line=%d\n",__LINE__);
			goto term;
		}

		//    
		
		int		type=UF_component_type;
		tag_t	object=NULL_TAG;

		int	i;

		//  
		for(i=0;i<30000;i++)
			rivet_bag[i]=NULL_TAG;
		
		rivet_count=0;

		errorCode=UF_OBJ_cycle_objs_in_part(disp_part,type,&object);
		PRTERR(__LINE__);

		if(object!=NULL_TAG)// 
			cycle_components(object);

		while(object!=NULL_TAG)
		{
			
			errorCode=UF_OBJ_cycle_objs_in_part(disp_part,type,&object);
			PRTERR(__LINE__);

			if(object!=NULL_TAG)// 
				cycle_components(object);

		}
	
	}

	fprintf(prterr,"rivet_count=%d\n",rivet_count);

	
	struct	fpdf_attributes
	{
		char	   pr_code  [2];
		char	   ad_code  [2];
		char	 fast_code [13];
		char	  grip_lng  [4];
		char	  point_id [13];
		tag_t		  rivet_tag;
	};

	struct fpdf_attributes	attr_array[30000];
	
	int						attr_cnt=0;						

	//1.     RIVET
	//2.    
	{
		int	
            attr_flag,
			i,
			title_type;

		
		UF_ATTR_value_t	value;
		
		
		for(i=0;i<rivet_count;i++)
		{//---------------------------------------------------------------------
			
			
			attr_flag=1;
			
			
			//   <pr_code>
			errorCode=UF_ATTR_find_attribute
				(rivet_bag[i],UF_ATTR_string,"PR_CODE",&title_type);
			PRTERR(__LINE__);
			

			if(title_type==UF_ATTR_string)
			{
				//   <pr_code>
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				//  UF_ATTR_string,    
				//memory access violation 
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				errorCode=UF_ATTR_read_value
					(rivet_bag[i],"PR_CODE",UF_ATTR_any,&value);
				PRTERR(__LINE__);
				
				
				if(value.value.string!=NULL)
					if(strlen(value.value.string)<2)
					{
						//  pr_code_temp;
						strcpy(attr_array[attr_cnt].pr_code,value.value.string);
						attr_cnt++;
					}

					else
					{
						attr_flag=0;
						//  
						fprintf
							(prterr,"  pr_code > 1	line=%d\n",__LINE__);
					}
				else
				{
					attr_flag=0;
					//  
					fprintf
						(prterr," pr_code  	line=%d\n",__LINE__);
				}
			}
			else
			{
				attr_flag=0;
				//  
				fprintf(prterr,"  pr_code	line=%d\n",__LINE__);
			}
		
			






			//   <ad_code>
			errorCode=UF_ATTR_find_attribute
				(rivet_bag[i],UF_ATTR_string,"AD_CODE",&title_type);
			PRTERR(__LINE__);
			
			if(title_type==UF_ATTR_string)
			{
				//   <ad_code>
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				//  UF_ATTR_string,    
				//memory access violation 
                //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				errorCode=UF_ATTR_read_value
					(rivet_bag[i],"AD_CODE",UF_ATTR_any,&value);
				PRTERR(__LINE__);
				
				if(value.value.string!=NULL)
					if(strlen(value.value.string)<2)
					{
						strcpy(attr_array[attr_cnt].pr_code,value.value.string);
						attr_cnt++;
					}
					else
					{
						attr_flag=0;
						//  
						fprintf(prterr,"  ad_code > 1	line=%d\n",__LINE__);
					}
				else
				{
					attr_flag=0;
					//  
					fprintf(prterr," ad_code  	line=%d\n",__LINE__);
				}
			}
			else
			{
				attr_flag=0;
				//  
				fprintf(prterr,"  ad_code	line=%d\n",__LINE__);
			}


			




			//   <fast_code>
			errorCode=UF_ATTR_find_attribute
				(rivet_bag[i],UF_ATTR_string,"FAST_CODE",&title_type);
			PRTERR(__LINE__);
			
			if(title_type==UF_ATTR_string)
			{
				//   <fast_code>
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				//  UF_ATTR_string,    
				//memory access violation 
                //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				errorCode=UF_ATTR_read_value
					(rivet_bag[i],"FAST_CODE",UF_ATTR_any,&value);
				PRTERR(__LINE__);
				
				if(value.value.string!=NULL)
					if(strlen(value.value.string)<13)
					{
						strcpy(attr_array[attr_cnt].pr_code,value.value.string);
						attr_cnt++;
					}
					else
					{
						attr_flag=0;
						//  
						fprintf(prterr," i=%d	  fast_code > 12	line=%d\n",i,__LINE__);
					}
				else
				{
					attr_flag=0;
					//  
					fprintf(prterr," i=%d	 fast_code  		line=%d\n",i,__LINE__);
				}
			}
			else
			{
				attr_flag=0;
				//  
				fprintf(prterr," i=%d	  fast_code	line=%d\n",i,__LINE__);
			}



			



			//   <grip_lng>
			errorCode=UF_ATTR_find_attribute
				(rivet_bag[i],UF_ATTR_string,"GRIP_LNG",&title_type);
			PRTERR(__LINE__);
			
			if(title_type==UF_ATTR_string)
			{
				//   <grip_lng>
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				//  UF_ATTR_string,    
				//memory access violation 
                //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				errorCode=UF_ATTR_read_value
					(rivet_bag[i],"GRIP_LNG",UF_ATTR_any,&value);
				PRTERR(__LINE__);
				
				if(value.value.string!=NULL)
					if(strlen(value.value.string)==3)
					{
						strcpy(attr_array[attr_cnt].pr_code,value.value.string);
						attr_cnt++;
					}
					else
					{
						attr_flag=0;
						fprintf(prterr," i=%d	  grip_lng != 3	line=%d\n",i,__LINE__);
					}
				else
				{
					attr_flag=0;
					fprintf(prterr," i=%d	 grip_lng  		line=%d\n",i,__LINE__);
				}
			}
			else
			{
				attr_flag=0;
				fprintf(prterr," i=%d	  fast_code	line=%d\n",i,__LINE__);
			}


		}//---------------------------------------------------------------------

	}







goto term;

term:
	fflush(prterr);
	return;
}






/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{

	
	






	//   
	struct	tm*		newtime;
	time_t			aclock,
					start_time,
					finish_time;
	double			work_time;
	int				min,sec;


	time(&start_time);

	//  prterr.txt    D:
	//
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

	//  prterr.txt   TEMP
	//
	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\TEMP\\",1);
		goto label_clock;
	}

	//  <prterr.txt>      
	//
	uc1601("     <prterr.txt>",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"<create_FPDF> STARTED		line=%d\n\n",__LINE__);
	fprintf(prterr,"    %s\n\n",asctime(newtime));
	fflush(prterr);

	errorCode=UF_initialize();PRTERR(__LINE__);

	do_it();

	errorCode=UF_terminate();PRTERR(__LINE__);

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n<create_FPDF> FINISHED		line=%d\n\n",__LINE__);
	fprintf(prterr,"work_time is	%u min	%u sec\n",min,sec);
	fflush(prterr);
	fclose(prterr);
	if(UF_is_initialized())
		UF_terminate();
	return;





	
	
	
	
	
	
	
	
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
